package com.company.testeformato.screen.teste001;

import com.company.testeformato.app.CargaTabBean;
import com.company.testeformato.entity.Tab001;
import com.company.testeformato.entity.Tab002;
import io.jmix.ui.Notifications;
import io.jmix.ui.component.Button;
import io.jmix.ui.component.Table;
import io.jmix.ui.component.TextField;
import io.jmix.ui.model.InstanceContainer;
import io.jmix.ui.screen.Screen;
import io.jmix.ui.screen.Subscribe;
import io.jmix.ui.screen.UiController;
import io.jmix.ui.screen.UiDescriptor;
import org.springframework.beans.factory.annotation.Autowired;

@UiController("BlankScreen")
@UiDescriptor("blank-screen.xml")
public class BlankScreen extends Screen {
    @Autowired
    private Notifications notifications;
    @Autowired
    private InstanceContainer<Tab001> tab001sDc;
    @Autowired
    private CargaTabBean cargaTabBean;
    @Autowired
    private TextField<Integer> numeroField;
    @Autowired
    private Table<Tab002> retornoPedidoesTable;
    @Autowired
    private TextField<Double> qtdItemField;
    @Autowired
    private TextField<String> descricaoField;
    @Autowired
    private TextField<Double> valorField;

    @Subscribe("btnPesquisar")
    public void onBtnPesquisarClick(Button.ClickEvent event) {
        CargaPedido();
    }

    private void CargaPedido() {

        try{
            tab001sDc.setItem(cargaTabBean.consultaTab(numeroField.getValue()));

            valorField.setValue(tab001sDc.getItem().getValor());

        }
        catch (Exception ee){
            notifications.create(Notifications.NotificationType.ERROR).withCaption(ee.getMessage()).show();
        }

    }

    @Subscribe("retornoPedidoesTable")
    public void onRetornoPedidoesTableSelection(Table.SelectionEvent<Tab002> event) {
        if (retornoPedidoesTable.getSingleSelected() == null)
            return;

        qtdItemField.setValue(retornoPedidoesTable.getSingleSelected().getQuantidade());
        descricaoField.setValue(retornoPedidoesTable.getSingleSelected().getDescricao());

    }
}